import PocketBase from 'pocketbase';
import { BatchServiceTS } from './services/BatchService.js';
import { RecordServiceTS } from './services/RecordService.js';
import type { BaseAuthStore } from 'pocketbase';
export type { UniqueCollection } from './helpers/type-utils.js';
import type { SchemaDeclaration } from './schema.js';
export declare class PocketBaseTS<TSchema extends SchemaDeclaration, TMaxDepth extends 0 | 1 | 2 | 3 | 4 | 5 | 6 = 2> extends PocketBase {
    #private;
    constructor(baseUrl?: string, authStore?: BaseAuthStore | null, lang?: string);
    collection<TName extends (keyof TSchema & string) | (string & {})>(idOrName: TName): RecordServiceTS<TSchema, TName, TMaxDepth>;
    createBatch(): BatchServiceTS<TSchema>;
}
