import PocketBase from 'pocketbase';
import { BatchServiceTS } from './services/BatchService.js';
import { RecordServiceTS } from './services/RecordService.js';
export class PocketBaseTS extends PocketBase {
    #recordServices = {};
    constructor(baseUrl, authStore, lang) {
        super(baseUrl, authStore, lang);
    }
    collection(idOrName) {
        if (!this.#recordServices[idOrName]) {
            this.#recordServices[idOrName] = new RecordServiceTS(this, idOrName);
        }
        return this.#recordServices[idOrName];
    }
    createBatch() {
        return new BatchServiceTS(this);
    }
}
