import PocketBase, { RecordService } from 'pocketbase';
import { processFilterAndSort, processOptions } from '../helpers/option-parser.js';
export class RecordServiceTS extends RecordService {
    constructor(client, idOrName) {
        super(client, idOrName);
    }
    async subscribe(topic, callback, options) {
        const processedOption = processOptions(options);
        return super.subscribe(topic, callback, processedOption);
    }
    async getFullList(options) {
        const processedOption = processOptions(options);
        return super.getFullList(processedOption);
    }
    async getList(page = 1, perPage = 30, options) {
        const processedOption = processOptions(options);
        return super.getList(page, perPage, processedOption);
    }
    async getFirstListItem(filter, options) {
        const processedFilter = processFilterAndSort(filter);
        const processedOption = processOptions(options);
        return super.getFirstListItem(processedFilter, processedOption);
    }
    async getOne(id, options) {
        const processedOption = processOptions(options);
        return super.getOne(id, processedOption);
    }
    async create(bodyParams, options) {
        const processedOption = processOptions(options);
        return super.create(bodyParams, processedOption);
    }
    async update(id, bodyParams, options) {
        const processedOption = processOptions(options);
        return super.update(id, bodyParams, processedOption);
    }
}
